(function($dvt$$19$$) {
  $dvt$$19$$.$TimeComponent$ = function $$dvt$$19$$$$TimeComponent$$($dvt$$19$$, $callback$$173$$, $callbackObj$$94$$) {
    this.Init($dvt$$19$$, $callback$$173$$, $callbackObj$$94$$);
  };
  $dvt$$19$$.$Obj$.$createSubclass$($dvt$$19$$.$TimeComponent$, $dvt$$19$$.$BaseComponent$);
  $dvt$$19$$.$TimeComponent$.$ZOOM_BY_VALUE$ = 1.5;
  $dvt$$19$$.$TimeComponent$.$SCROLL_LINE_HEIGHT$ = 15;
  $dvt$$19$$.$TimeComponent$.$WHEEL_UNITS_PER_LINE$ = 40;
  $dvt$$19$$.$TimeComponent$.prototype.Init = function $$dvt$$19$$$$TimeComponent$$$Init$($context$$427$$, $callback$$174$$, $callbackObj$$95$$) {
    $dvt$$19$$.$TimeComponent$.$superclass$.Init.call(this, $context$$427$$, $callback$$174$$, $callbackObj$$95$$);
    this.$_virtualize$ = !1;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$render$ = function $$dvt$$19$$$$TimeComponent$$$$render$$($dvt$$19$$, $width$$146$$, $height$$123$$) {
    $dvt$$19$$ && (this.$_resources$ = $dvt$$19$$._resources, null == this.$_resources$ && (this.$_resources$ = []), this.$SetOptions$($dvt$$19$$));
    this.$Width$ = $width$$146$$;
    this.$Height$ = $height$$123$$;
    this.$Options$ && ($dvt$$19$$ = this.$Parse$(this.$Options$), this.$_applyParsedProperties$($dvt$$19$$));
  };
  $dvt$$19$$.$TimeComponent$.prototype.$SetOptions$ = function $$dvt$$19$$$$TimeComponent$$$$SetOptions$$($options$$361$$) {
    this.$Options$ = this.$Defaults$.$calcOptions$($options$$361$$);
    $dvt$$19$$.$Agent$.$isEnvironmentBrowser$() || (this.$Options$.animationOnDisplay = "none", this.$Options$.animationOnDataChange = "none");
  };
  $dvt$$19$$.$TimeComponent$.prototype.$_applyParsedProperties$ = function $$dvt$$19$$$$TimeComponent$$$$_applyParsedProperties$$($dvt$$19$$) {
    this.$_start$ = $dvt$$19$$.start;
    this.$_end$ = $dvt$$19$$.end;
    this.$_inlineStyle$ = $dvt$$19$$.$inlineStyle$;
    this.$applyStyleValues$();
  };
  $dvt$$19$$.$TimeComponent$.prototype.$applyStyleValues$ = function $$dvt$$19$$$$TimeComponent$$$$applyStyleValues$$() {
    this.$_style$ && this.$_style$.$parseInlineStyle$(this.$_inlineStyle$);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$setContentLength$ = function $$dvt$$19$$$$TimeComponent$$$$setContentLength$$($dvt$$19$$) {
    this.$_contentLength$ = this.$_canvasLength$ < $dvt$$19$$ ? $dvt$$19$$ : this.$_canvasLength$;
    this.$_virtualize$ || (this.$_fetchStartPos$ = 0, this.$_fetchEndPos$ = this.$_contentLength$);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$isRTL$ = function $$dvt$$19$$$$TimeComponent$$$$isRTL$$() {
    return $dvt$$19$$.$Agent$.$isRightToLeft$(this.$getCtx$());
  };
  $dvt$$19$$.$TimeComponent$.prototype.$isVertical$ = function $$dvt$$19$$$$TimeComponent$$$$isVertical$$() {
    return this.$_isVertical$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$getTimeAxis$ = function $$dvt$$19$$$$TimeComponent$$$$getTimeAxis$$() {
    return null;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$prepareViewportLength$ = function $$dvt$$19$$$$TimeComponent$$$$prepareViewportLength$$() {
    this.$setRelativeStartPos$(0);
    if (this.$_viewStartTime$ && this.$_viewEndTime$) {
      var $dvt$$19$$ = this.$_viewEndTime$ - this.$_viewStartTime$;
      0 < $dvt$$19$$ && ($dvt$$19$$ = this.$_canvasLength$ / $dvt$$19$$, this.$setContentLength$($dvt$$19$$ * (this.$_end$ - this.$_start$)), this.$setRelativeStartPos$($dvt$$19$$ * (this.$_start$ - this.$_viewStartTime$)));
    } else {
      var $dvt$$19$$ = this.$getTimeAxis$(), $dvt$$19$$ = $dvt$$19$$.$_zoomLevelLengths$[$dvt$$19$$.$_zoomLevelOrder$], $startTime$$20$$ = this.$_start$, $endTime$$17$$ = this.$_end$;
      null == this.$_viewStartTime$ ? null != this.$_viewEndTime$ ? (this.$_viewStartTime$ = this.$_viewEndTime$ - this.$_canvasLength$ / $dvt$$19$$ * ($endTime$$17$$ - $startTime$$20$$), this.$_viewStartTime$ < this.$_start$ && (this.$_viewStartTime$ = this.$_start$), $dvt$$19$$ = this.$_viewEndTime$ - this.$_viewStartTime$, $dvt$$19$$ = this.$_canvasLength$ / $dvt$$19$$, this.$setContentLength$($dvt$$19$$ * (this.$_end$ - this.$_start$)), this.$setRelativeStartPos$($dvt$$19$$ * (this.$_start$ - 
      this.$_viewStartTime$))) : (this.$_viewStartTime$ = this.$_start$, this.$setRelativeStartPos$(0), this.$_viewEndTime$ = this.$_canvasLength$ / $dvt$$19$$ * ($endTime$$17$$ - $startTime$$20$$) + this.$_viewStartTime$, this.$_viewEndTime$ > this.$_end$ && (this.$_viewEndTime$ = this.$_end$)) : (this.$_viewEndTime$ = this.$_canvasLength$ / $dvt$$19$$ * ($endTime$$17$$ - $startTime$$20$$) + this.$_viewStartTime$, this.$_viewEndTime$ > this.$_end$ && (this.$_viewEndTime$ = this.$_end$), $dvt$$19$$ = 
      this.$_viewEndTime$ - this.$_viewStartTime$, $dvt$$19$$ = this.$_canvasLength$ / $dvt$$19$$, this.$setContentLength$($dvt$$19$$ * (this.$_end$ - this.$_start$)), this.$setRelativeStartPos$($dvt$$19$$ * (this.$_start$ - this.$_viewStartTime$)));
    }
  };
  $dvt$$19$$.$TimeComponent$.prototype.$renderTimeZoomCanvas$ = function $$dvt$$19$$$$TimeComponent$$$$renderTimeZoomCanvas$$($container$$198$$) {
    this.$_timeZoomCanvas$ ? this.$_timeZoomCanvas$.$setClipPath$(null) : this.$_timeZoomCanvas$ = new $dvt$$19$$.$Container$(this.$getCtx$(), "iCanvas");
    var $cp$$13$$ = new $dvt$$19$$.$ClipPath$;
    this.$isVertical$() ? ($cp$$13$$.$addRect$(this.$_startX$, this.$_startY$, this.$_canvasSize$, this.$_canvasLength$), this.$_timeZoomCanvas$.$setTranslateX$(this.$_startX$), this.$_timeZoomCanvas$.$setTranslateY$(this.$_startY$ + this.$_startPos$)) : ($cp$$13$$.$addRect$(this.$_startX$, this.$_startY$, this.$_canvasLength$, this.$_canvasSize$), this.$_timeZoomCanvas$.$setTranslateX$(this.$_startX$ + this.$_startPos$), this.$_timeZoomCanvas$.$setTranslateY$(this.$_startY$));
    $container$$198$$.$setClipPath$($cp$$13$$);
    this.$_timeZoomCanvas$.getParent() != $container$$198$$ && $container$$198$$.$addChild$(this.$_timeZoomCanvas$);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$renderZoomControls$ = function $$dvt$$19$$$$TimeComponent$$$$renderZoomControls$$($options$$362_zoomOutOptions_zoomOutPosY$$1$$) {
    var $contentLength_context$$428$$ = this.$getCtx$(), $timeAxis$$7$$ = this.$getTimeAxis$(), $zoomInOptions_zoomInPosY$$1$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.zoomInProps, $disabledState_imageSize$$ = $zoomInOptions_zoomInPosY$$1$$.imageSize, $cssUrl_upState$$17$$ = $zoomInOptions_zoomInPosY$$1$$.cssUrl, $cssUrlHover_overState$$14$$ = $zoomInOptions_zoomInPosY$$1$$.cssUrlHover, $cssUrlActive_downState$$14$$ = $zoomInOptions_zoomInPosY$$1$$.cssUrlActive, $cssUrlDisabled_zoomOutPosX$$ = 
    $zoomInOptions_zoomInPosY$$1$$.cssUrlDisabled, $enabledBackgroundColor$$ = $zoomInOptions_zoomInPosY$$1$$.enabledBackgroundColor, $enabledBorderColor$$ = $zoomInOptions_zoomInPosY$$1$$.enabledBorderColor, $DvtTimeComponentStyleUtils$$ = $zoomInOptions_zoomInPosY$$1$$.hoverBackgroundColor, $hoverBorderColor$$ = $zoomInOptions_zoomInPosY$$1$$.hoverBorderColor, $activeBackgroundColor$$ = $zoomInOptions_zoomInPosY$$1$$.activeBackgroundColor, $activeBorderColor$$ = $zoomInOptions_zoomInPosY$$1$$.activeBorderColor, 
    $disabledBackgroundColor$$ = $zoomInOptions_zoomInPosY$$1$$.disabledBackgroundColor, $disabledBorderColor$$ = $zoomInOptions_zoomInPosY$$1$$.disabledBorderColor, $cssUrl_upState$$17$$ = $dvt$$19$$.$TransientButton$.$getStateFromURL$($contentLength_context$$428$$, $cssUrl_upState$$17$$, $disabledState_imageSize$$, $disabledState_imageSize$$, $enabledBackgroundColor$$, $enabledBorderColor$$), $cssUrlHover_overState$$14$$ = $dvt$$19$$.$TransientButton$.$getStateFromURL$($contentLength_context$$428$$, 
    $cssUrlHover_overState$$14$$, $disabledState_imageSize$$, $disabledState_imageSize$$, $DvtTimeComponentStyleUtils$$, $hoverBorderColor$$), $cssUrlActive_downState$$14$$ = $dvt$$19$$.$TransientButton$.$getStateFromURL$($contentLength_context$$428$$, $cssUrlActive_downState$$14$$, $disabledState_imageSize$$, $disabledState_imageSize$$, $activeBackgroundColor$$, $activeBorderColor$$), $disabledState_imageSize$$ = $dvt$$19$$.$TransientButton$.$getStateFromURL$($contentLength_context$$428$$, $cssUrlDisabled_zoomOutPosX$$, 
    $disabledState_imageSize$$, $disabledState_imageSize$$, $disabledBackgroundColor$$, $disabledBorderColor$$), $zoomInPosX$$ = $zoomInOptions_zoomInPosY$$1$$.posX, $zoomInOptions_zoomInPosY$$1$$ = $zoomInOptions_zoomInPosY$$1$$.posY;
    null == this.$zoomin$ ? (this.$zoomin$ = new $dvt$$19$$.$TransientButton$($contentLength_context$$428$$, $cssUrl_upState$$17$$, $cssUrlHover_overState$$14$$, $cssUrlActive_downState$$14$$, $disabledState_imageSize$$, this.$EventManager$, this.$EventManager$.$HandleZoomInClick$), this.$EventManager$.$associate$(this.$zoomin$, this.$zoomin$)) : (this.$zoomin$.$setUpState$($cssUrl_upState$$17$$), this.$zoomin$.$setOverState$($cssUrlHover_overState$$14$$), this.$zoomin$.$setDownState$($cssUrlActive_downState$$14$$), 
    this.$zoomin$.$setDisabledState$($disabledState_imageSize$$));
    $options$$362_zoomOutOptions_zoomOutPosY$$1$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.zoomOutProps;
    $disabledState_imageSize$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.imageSize;
    $cssUrl_upState$$17$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.cssUrl;
    $cssUrlHover_overState$$14$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.cssUrlHover;
    $cssUrlActive_downState$$14$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.cssUrlActive;
    $cssUrlDisabled_zoomOutPosX$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.cssUrlDisabled;
    $enabledBackgroundColor$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.enabledBackgroundColor;
    $enabledBorderColor$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.enabledBorderColor;
    $DvtTimeComponentStyleUtils$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.hoverBackgroundColor;
    $hoverBorderColor$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.hoverBorderColor;
    $activeBackgroundColor$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.activeBackgroundColor;
    $activeBorderColor$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.activeBorderColor;
    $disabledBackgroundColor$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.disabledBackgroundColor;
    $disabledBorderColor$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.disabledBorderColor;
    $cssUrl_upState$$17$$ = $dvt$$19$$.$TransientButton$.$getStateFromURL$($contentLength_context$$428$$, $cssUrl_upState$$17$$, $disabledState_imageSize$$, $disabledState_imageSize$$, $enabledBackgroundColor$$, $enabledBorderColor$$);
    $cssUrlHover_overState$$14$$ = $dvt$$19$$.$TransientButton$.$getStateFromURL$($contentLength_context$$428$$, $cssUrlHover_overState$$14$$, $disabledState_imageSize$$, $disabledState_imageSize$$, $DvtTimeComponentStyleUtils$$, $hoverBorderColor$$);
    $cssUrlActive_downState$$14$$ = $dvt$$19$$.$TransientButton$.$getStateFromURL$($contentLength_context$$428$$, $cssUrlActive_downState$$14$$, $disabledState_imageSize$$, $disabledState_imageSize$$, $activeBackgroundColor$$, $activeBorderColor$$);
    $disabledState_imageSize$$ = $dvt$$19$$.$TransientButton$.$getStateFromURL$($contentLength_context$$428$$, $cssUrlDisabled_zoomOutPosX$$, $disabledState_imageSize$$, $disabledState_imageSize$$, $disabledBackgroundColor$$, $disabledBorderColor$$);
    $cssUrlDisabled_zoomOutPosX$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.posX;
    $options$$362_zoomOutOptions_zoomOutPosY$$1$$ = $options$$362_zoomOutOptions_zoomOutPosY$$1$$.posY;
    null == this.$zoomout$ ? (this.$zoomout$ = new $dvt$$19$$.$TransientButton$($contentLength_context$$428$$, $cssUrl_upState$$17$$, $cssUrlHover_overState$$14$$, $cssUrlActive_downState$$14$$, $disabledState_imageSize$$, this.$EventManager$, this.$EventManager$.$HandleZoomOutClick$), this.$EventManager$.$associate$(this.$zoomout$, this.$zoomout$)) : (this.$zoomout$.$setUpState$($cssUrl_upState$$17$$), this.$zoomout$.$setOverState$($cssUrlHover_overState$$14$$), this.$zoomout$.$setDownState$($cssUrlActive_downState$$14$$), 
    this.$zoomout$.$setDisabledState$($disabledState_imageSize$$));
    this.$zoomin$.$setTooltip$($dvt$$19$$.$Bundle$.$getTranslatedString$($dvt$$19$$.$Bundle$.$UTIL_PREFIX$, "ZOOM_IN", null));
    this.$zoomout$.$setTooltip$($dvt$$19$$.$Bundle$.$getTranslatedString$($dvt$$19$$.$Bundle$.$UTIL_PREFIX$, "ZOOM_OUT", null));
    this.$zoomin$.$hide$();
    this.$zoomout$.$hide$();
    $dvt$$19$$.$TimeAxis$.$supportsTouch$() && ($dvt$$19$$.$ToolkitUtils$.$setAttrNullNS$(this.$zoomin$.$getElem$(), "role", "button"), $dvt$$19$$.$ToolkitUtils$.$setAttrNullNS$(this.$zoomin$.$getElem$(), "aria-label", $dvt$$19$$.$Bundle$.$getTranslatedString$($dvt$$19$$.$Bundle$.$UTIL_PREFIX$, "ZOOM_IN", null)), $dvt$$19$$.$ToolkitUtils$.$setAttrNullNS$(this.$zoomout$.$getElem$(), "role", "button"), $dvt$$19$$.$ToolkitUtils$.$setAttrNullNS$(this.$zoomout$.$getElem$(), "aria-label", $dvt$$19$$.$Bundle$.$getTranslatedString$($dvt$$19$$.$Bundle$.$UTIL_PREFIX$, 
    "ZOOM_OUT", null)));
    this.$zoomin$.$setTranslateX$($zoomInPosX$$);
    this.$zoomout$.$setTranslateX$($cssUrlDisabled_zoomOutPosX$$);
    this.$zoomin$.$setTranslateY$($zoomInOptions_zoomInPosY$$1$$);
    this.$zoomout$.$setTranslateY$($options$$362_zoomOutOptions_zoomOutPosY$$1$$);
    this.$zoomin$.getParent() != this.$_canvas$ && this.$_canvas$.$addChild$(this.$zoomin$);
    this.$zoomout$.getParent() != this.$_canvas$ && this.$_canvas$.$addChild$(this.$zoomout$);
    $contentLength_context$$428$$ = this.$_contentLength$;
    $contentLength_context$$428$$ >= $timeAxis$$7$$.$_maxContentLength$ && this.$disableZoomButton$(!0);
    this.$_canvasLength$ >= $contentLength_context$$428$$ && this.$disableZoomButton$(!1);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$HandleMouseWheel$ = function $$dvt$$19$$$$TimeComponent$$$$HandleMouseWheel$$($event$$546$$) {
    $dvt$$19$$.$EventManager$.$consumeEvent$($event$$546$$);
    var $wheelDelta$$ = $event$$546$$.wheelDelta, $compLoc$$2_compPagePos_wheelEvent$$ = $event$$546$$.$getNativeEvent$();
    if (this.$hasValidOptions$() && (null != $compLoc$$2_compPagePos_wheelEvent$$.wheelDeltaX ? $event$$546$$.wheelDeltaX = $compLoc$$2_compPagePos_wheelEvent$$.wheelDeltaX / $dvt$$19$$.$TimeComponent$.$WHEEL_UNITS_PER_LINE$ : null != $compLoc$$2_compPagePos_wheelEvent$$.deltaX && ($compLoc$$2_compPagePos_wheelEvent$$.deltaMode == $compLoc$$2_compPagePos_wheelEvent$$.DOM_DELTA_LINE ? $event$$546$$.wheelDeltaX = -$compLoc$$2_compPagePos_wheelEvent$$.deltaX : $compLoc$$2_compPagePos_wheelEvent$$.deltaMode == 
    $compLoc$$2_compPagePos_wheelEvent$$.DOM_DELTA_PIXEL && ($event$$546$$.wheelDeltaX = -$compLoc$$2_compPagePos_wheelEvent$$.deltaX / $dvt$$19$$.$TimeComponent$.$SCROLL_LINE_HEIGHT$)), $wheelDelta$$)) {
      var $compLoc$$2_compPagePos_wheelEvent$$ = this.$getCtx$().$getStageAbsolutePosition$(), $compLoc$$2_compPagePos_wheelEvent$$ = this.$_isVertical$ ? $event$$546$$.pageY - $compLoc$$2_compPagePos_wheelEvent$$.y : $event$$546$$.pageX - $compLoc$$2_compPagePos_wheelEvent$$.x, $time$$19_widthFactor$$1$$ = (this.$_end$ - this.$_start$) / this.$_contentLength$, $time$$19_widthFactor$$1$$ = this.$isRTL$() && !this.$_isVertical$ ? this.$_viewEndTime$ - $time$$19_widthFactor$$1$$ * $compLoc$$2_compPagePos_wheelEvent$$ : 
      $time$$19_widthFactor$$1$$ * $compLoc$$2_compPagePos_wheelEvent$$ + this.$_viewStartTime$;
      $event$$546$$.$zoomTime$ = $time$$19_widthFactor$$1$$;
      $event$$546$$.$zoomCompLoc$ = $compLoc$$2_compPagePos_wheelEvent$$;
      $event$$546$$.$zoomWheelDelta$ = .02 * $wheelDelta$$ + 1;
    }
  };
  $dvt$$19$$.$TimeComponent$.prototype.$handleZoomWheel$ = function $$dvt$$19$$$$TimeComponent$$$$handleZoomWheel$$($dvt$$19$$, $time$$20$$, $compLoc$$3$$) {
    var $viewLength_widthFactor$$2$$ = (this.$_viewEndTime$ - this.$_viewStartTime$) / (this.$_end$ - this.$_start$) * this.$_contentLength$;
    this.$setContentLength$($dvt$$19$$);
    $dvt$$19$$ = $viewLength_widthFactor$$2$$ / this.$_contentLength$ * (this.$_end$ - this.$_start$);
    $time$$20$$ ? ($viewLength_widthFactor$$2$$ = (this.$_end$ - this.$_start$) / this.$_contentLength$, this.$isRTL$() && !this.$_isVertical$ ? (this.$_viewEndTime$ = $time$$20$$ + $compLoc$$3$$ * $viewLength_widthFactor$$2$$, this.$_viewEndTime$ > this.$_end$ && (this.$_viewEndTime$ = this.$_end$), this.$_viewStartTime$ = this.$_viewEndTime$ - $dvt$$19$$, this.$_viewStartTime$ < this.$_start$ && (this.$_viewStartTime$ = this.$_start$, this.$_viewEndTime$ = this.$_viewStartTime$ + $dvt$$19$$, this.$_viewEndTime$ > 
    this.$_end$ && (this.$_viewEndTime$ = this.$_end$))) : (this.$_viewStartTime$ = $time$$20$$ - $compLoc$$3$$ * $viewLength_widthFactor$$2$$, this.$_viewStartTime$ < this.$_start$ && (this.$_viewStartTime$ = this.$_start$), this.$_viewEndTime$ = this.$_viewStartTime$ + $dvt$$19$$, this.$_viewEndTime$ > this.$_end$ && (this.$_viewEndTime$ = this.$_end$, this.$_viewStartTime$ = this.$_viewEndTime$ - $dvt$$19$$, this.$_viewStartTime$ < this.$_start$ && (this.$_viewStartTime$ = this.$_start$))), this.$setRelativeStartPos$(1 / 
    $viewLength_widthFactor$$2$$ * (this.$_start$ - this.$_viewStartTime$))) : (this.$_viewStartTime$ = this.$_start$, this.$_viewEndTime$ = this.$_viewStartTime$ + $dvt$$19$$, this.$_viewStartTime$ < this.$_start$ && (this.$_viewStartTime$ = this.$_start$), this.$setRelativeStartPos$(0));
    this.$applyTimeZoomCanvasPosition$();
  };
  $dvt$$19$$.$TimeComponent$.prototype.$zoomBy$ = function $$dvt$$19$$$$TimeComponent$$$$zoomBy$$($dvt$$19$$) {
    var $compLoc$$4$$ = this.$_isVertical$ ? this.$Height$ / 2 : this.$Width$ / 2;
    this.$handleZoomWheel$(this.$_contentLength$ * ((1 / $dvt$$19$$ - 1) / 2 + 1), (this.$_end$ - this.$_start$) / this.$_contentLength$ * $compLoc$$4$$ + this.$_viewStartTime$, $compLoc$$4$$, !0);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$beginPinchZoom$ = function $$dvt$$19$$$$TimeComponent$$$$beginPinchZoom$$($dvt$$19$$, $y1$$33$$, $x2$$44$$, $y2$$32$$) {
    this.$_initialPinchZoomLoc$ = this.$_isVertical$ ? Math.sqrt(($y1$$33$$ - $y2$$32$$) * ($y1$$33$$ - $y2$$32$$)) + ($y1$$33$$ < $y2$$32$$ ? $y1$$33$$ : $y2$$32$$) : Math.sqrt(($dvt$$19$$ - $x2$$44$$) * ($dvt$$19$$ - $x2$$44$$)) + ($dvt$$19$$ < $x2$$44$$ ? $dvt$$19$$ : $x2$$44$$);
    this.$_initialPinchZoomTime$ = (this.$_end$ - this.$_start$) / this.$_contentLength$ * this.$_initialPinchZoomLoc$ + this.$_viewStartTime$;
    this.$_initialPinchZoomDist$ = Math.sqrt(($dvt$$19$$ - $x2$$44$$) * ($dvt$$19$$ - $x2$$44$$) + ($y1$$33$$ - $y2$$32$$) * ($y1$$33$$ - $y2$$32$$));
    this.$_initialPinchZoomLength$ = this.$_contentLength$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$contPinchZoom$ = function $$dvt$$19$$$$TimeComponent$$$$contPinchZoom$$($dvt$$19$$, $y1$$34$$, $x2$$45$$, $y2$$33$$) {
    $dvt$$19$$ = Math.sqrt(($dvt$$19$$ - $x2$$45$$) * ($dvt$$19$$ - $x2$$45$$) + ($y1$$34$$ - $y2$$33$$) * ($y1$$34$$ - $y2$$33$$));
    $dvt$$19$$ != this.$_initialPinchZoomDist$ && (this.$_triggerViewportChange$ = !0);
    this.$handleZoomWheel$($dvt$$19$$ / this.$_initialPinchZoomDist$ * this.$_initialPinchZoomLength$, this.$_initialPinchZoomTime$, this.$_initialPinchZoomLoc$, !1);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$endPinchZoom$ = function $$dvt$$19$$$$TimeComponent$$$$endPinchZoom$$() {
    this.$_initialPinchZoomTime$ = this.$_initialPinchZoomLength$ = this.$_initialPinchZoomLoc$ = this.$_initialPinchZoomDist$ = null;
    this.$_triggerViewportChange$ && (this.$_triggerViewportChange$ = !1, this.dispatchEvent(this.$createViewportChangeEvent$()));
  };
  $dvt$$19$$.$TimeComponent$.prototype.$panZoomCanvasBy$ = function $$dvt$$19$$$$TimeComponent$$$$panZoomCanvasBy$$($dvt$$19$$) {
    if (this.$_isVertical$) {
      $dvt$$19$$ = this.$_timeZoomCanvas$.$getTranslateY$() - $dvt$$19$$;
      var $minTranslateX_minTranslateY$$1_widthFactor$$5$$ = -(this.$_contentLength$ - this.$_canvasLength$ - this.$_startY$), $maxTranslateX_maxTranslateY$$1_viewTime$$2$$ = this.$_startY$;
      $dvt$$19$$ < $minTranslateX_minTranslateY$$1_widthFactor$$5$$ ? $dvt$$19$$ = $minTranslateX_minTranslateY$$1_widthFactor$$5$$ : $dvt$$19$$ > $maxTranslateX_maxTranslateY$$1_viewTime$$2$$ && ($dvt$$19$$ = $maxTranslateX_maxTranslateY$$1_viewTime$$2$$);
      this.$_timeZoomCanvas$.$setTranslateY$($dvt$$19$$);
      $dvt$$19$$ -= this.$_startY$;
      this.$setAbsoluteStartPos$($dvt$$19$$);
    } else {
      $dvt$$19$$ = this.$_timeZoomCanvas$.$getTranslateX$() - $dvt$$19$$, $minTranslateX_minTranslateY$$1_widthFactor$$5$$ = -(this.$_contentLength$ - this.$_canvasLength$ - this.$_startX$), $maxTranslateX_maxTranslateY$$1_viewTime$$2$$ = this.$_startX$, $dvt$$19$$ < $minTranslateX_minTranslateY$$1_widthFactor$$5$$ ? $dvt$$19$$ = $minTranslateX_minTranslateY$$1_widthFactor$$5$$ : $dvt$$19$$ > $maxTranslateX_maxTranslateY$$1_viewTime$$2$$ && ($dvt$$19$$ = $maxTranslateX_maxTranslateY$$1_viewTime$$2$$), 
      this.$_timeZoomCanvas$.$setTranslateX$($dvt$$19$$), this.$setAbsoluteStartPos$($dvt$$19$$ - this.$_startX$), $dvt$$19$$ = this.$getRelativeStartPos$();
    }
    $minTranslateX_minTranslateY$$1_widthFactor$$5$$ = this.$_contentLength$ / (this.$_end$ - this.$_start$);
    $maxTranslateX_maxTranslateY$$1_viewTime$$2$$ = this.$_viewEndTime$ - this.$_viewStartTime$;
    this.$_viewStartTime$ = this.$_start$ - $dvt$$19$$ / $minTranslateX_minTranslateY$$1_widthFactor$$5$$;
    this.$_viewEndTime$ = this.$_viewStartTime$ + $maxTranslateX_maxTranslateY$$1_viewTime$$2$$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$handleZoom$ = function $$dvt$$19$$$$TimeComponent$$$$handleZoom$$($zoomIn$$1$$) {
    $zoomIn$$1$$ ? this.$zoomBy$(1 / $dvt$$19$$.$TimeComponent$.$ZOOM_BY_VALUE$) : this.$zoomBy$($dvt$$19$$.$TimeComponent$.$ZOOM_BY_VALUE$);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$enableZoomButton$ = function $$dvt$$19$$$$TimeComponent$$$$enableZoomButton$$($dvt$$19$$) {
    $dvt$$19$$ ? (this.$zoomin$.$setEnabled$(!0), this.$zoomin$.$drawUpState$()) : (this.$zoomout$.$setEnabled$(!0), this.$zoomout$.$drawUpState$());
  };
  $dvt$$19$$.$TimeComponent$.prototype.$disableZoomButton$ = function $$dvt$$19$$$$TimeComponent$$$$disableZoomButton$$($dvt$$19$$) {
    $dvt$$19$$ ? (this.$zoomin$.$setEnabled$(!1), this.$zoomin$.$drawDisabledState$(), this.$zoomin$.setCursor(null)) : (this.$zoomout$.$setEnabled$(!1), this.$zoomout$.$drawDisabledState$(), this.$zoomout$.setCursor(null));
  };
  $dvt$$19$$.$TimeComponent$.prototype.$applyTimeZoomCanvasPosition$ = function $$dvt$$19$$$$TimeComponent$$$$applyTimeZoomCanvasPosition$$() {
    this.$_isVertical$ ? this.$_timeZoomCanvas$.$setTranslateY$(this.$_startY$ + this.$_startPos$) : this.$_timeZoomCanvas$.$setTranslateX$(this.$_startX$ + this.$_startPos$);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$setAbsoluteStartPos$ = function $$dvt$$19$$$$TimeComponent$$$$setAbsoluteStartPos$$($dvt$$19$$) {
    this.$_startPos$ = $dvt$$19$$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$getRelativeStartPos$ = function $$dvt$$19$$$$TimeComponent$$$$getRelativeStartPos$$() {
    return this.$isRTL$() && !this.$_isVertical$ ? this.$_canvasLength$ - this.$_contentLength$ - this.$_startPos$ : this.$_startPos$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$setRelativeStartPos$ = function $$dvt$$19$$$$TimeComponent$$$$setRelativeStartPos$$($dvt$$19$$) {
    this.$isRTL$() && !this.$_isVertical$ ? this.$_startPos$ = this.$_canvasLength$ - this.$_contentLength$ - $dvt$$19$$ : this.$_startPos$ = $dvt$$19$$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$setStartXOffset$ = function $$dvt$$19$$$$TimeComponent$$$$setStartXOffset$$($dvt$$19$$) {
    this.$_startX$ = $dvt$$19$$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$setStartYOffset$ = function $$dvt$$19$$$$TimeComponent$$$$setStartYOffset$$($dvt$$19$$) {
    this.$_startY$ = $dvt$$19$$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$getGraphicalAreaBounds$ = function $$dvt$$19$$$$TimeComponent$$$$getGraphicalAreaBounds$$() {
    return this.$isVertical$() ? new $dvt$$19$$.$Rectangle$(this.$_startX$, this.$_startY$, this.$_canvasSize$, this.$_canvasLength$) : new $dvt$$19$$.$Rectangle$(this.$_startX$, this.$_startY$, this.$_canvasLength$, this.$_canvasSize$);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$isTimeDirScrollbarOn$ = function $$dvt$$19$$$$TimeComponent$$$$isTimeDirScrollbarOn$$() {
    return !0;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$setTimeDirScrollbar$ = function $$dvt$$19$$$$TimeComponent$$$$setTimeDirScrollbar$$($dvt$$19$$) {
    this.$timeDirScrollbar$ = $dvt$$19$$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$setContentDirScrollbar$ = function $$dvt$$19$$$$TimeComponent$$$$setContentDirScrollbar$$($dvt$$19$$, $index$$205$$) {
    null != $index$$205$$ ? (null == this.$contentDirScrollbar$ && (this.$contentDirScrollbar$ = []), this.$contentDirScrollbar$[$index$$205$$] = $dvt$$19$$) : this.$contentDirScrollbar$ = $dvt$$19$$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$getScrollbarPadding$ = function $$dvt$$19$$$$TimeComponent$$$$getScrollbarPadding$$() {
    return $DvtTimeComponentStyleUtils$$.$_SCROLLBAR_PADDING$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$getTimeDirScrollbarStyle$ = function $$dvt$$19$$$$TimeComponent$$$$getTimeDirScrollbarStyle$$() {
    return $DvtTimeComponentStyleUtils$$.$getTimeDirScrollbarStyle$();
  };
  $dvt$$19$$.$TimeComponent$.prototype.$getContentDirScrollbarStyle$ = function $$dvt$$19$$$$TimeComponent$$$$getContentDirScrollbarStyle$$() {
    return $DvtTimeComponentStyleUtils$$.$getContentDirScrollbarStyle$();
  };
  $dvt$$19$$.$TimeComponent$.prototype.$HandleEvent$ = function $$dvt$$19$$$$TimeComponent$$$$HandleEvent$$($event$$547$$, $component$$27$$) {
    $event$$547$$.type == $dvt$$19$$.$SimpleScrollbarEvent$.$TYPE$ && ($event$$547$$ = this.$processScrollbarEvent$($event$$547$$, $component$$27$$));
    $event$$547$$ && this.dispatchEvent($event$$547$$);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$processScrollbarEvent$ = function $$dvt$$19$$$$TimeComponent$$$$processScrollbarEvent$$($dvt$$19$$, $component$$28$$) {
    if ($component$$28$$ == this.$timeDirScrollbar$) {
      var $evt$$62_newMax$$1$$ = $dvt$$19$$.$_newMax$;
      this.$_viewStartTime$ = $dvt$$19$$.$_newMin$;
      this.$_viewEndTime$ = $evt$$62_newMax$$1$$;
      this.$setRelativeStartPos$(this.$_contentLength$ / (this.$_end$ - this.$_start$) * (this.$_start$ - this.$_viewStartTime$));
      this.$applyTimeZoomCanvasPosition$();
      $evt$$62_newMax$$1$$ = this.$createViewportChangeEvent$();
      this.dispatchEvent($evt$$62_newMax$$1$$);
    }
  };
  $dvt$$19$$.$TimeComponent$.prototype.$processEvent$ = function $$dvt$$19$$$$TimeComponent$$$$processEvent$$($dvt$$19$$) {
    $dvt$$19$$ && this.dispatchEvent($dvt$$19$$);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$createViewportChangeEvent$ = function $$dvt$$19$$$$TimeComponent$$$$createViewportChangeEvent$$() {
    return null;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$HandleKeyDown$ = function $$dvt$$19$$$$TimeComponent$$$$HandleKeyDown$$() {
  };
  $dvt$$19$$.$TimeComponent$.prototype.$HandleMouseDown$ = function $$dvt$$19$$$$TimeComponent$$$$HandleMouseDown$$() {
  };
  $dvt$$19$$.$TimeComponent$.prototype.$HandleFocus$ = function $$dvt$$19$$$$TimeComponent$$$$HandleFocus$$() {
    null != this.$zoomin$ && this.$zoomin$.$_onFocus$();
    null != this.$zoomout$ && this.$zoomout$.$_onFocus$();
  };
  $dvt$$19$$.$TimeComponent$.prototype.$HandleBlur$ = function $$dvt$$19$$$$TimeComponent$$$$HandleBlur$$() {
    null != this.$zoomin$ && this.$zoomin$.$_onBlur$();
    null != this.$zoomout$ && this.$zoomout$.$_onBlur$();
  };
  $dvt$$19$$.$TimeComponent$.prototype.$beginDragPan$ = function $$dvt$$19$$$$TimeComponent$$$$beginDragPan$$($dvt$$19$$, $compY$$4$$) {
    this.$_currentX$ = $dvt$$19$$;
    this.$_currentY$ = $compY$$4$$;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$endDragPan$ = function $$dvt$$19$$$$TimeComponent$$$$endDragPan$$() {
    this.$endPan$();
  };
  $dvt$$19$$.$TimeComponent$.prototype.$HandleTouchEnd$ = function $$dvt$$19$$$$TimeComponent$$$$HandleTouchEnd$$($dvt$$19$$) {
    "none" != this.$_selectionMode$ && this.$handleShapeClick$($dvt$$19$$, "multiple" == this.$_selectionMode$);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$handleShapeClick$ = function $$dvt$$19$$$$TimeComponent$$$$handleShapeClick$$() {
  };
  $dvt$$19$$.$TimeComponent$.prototype.$HandleMouseClick$ = function $$dvt$$19$$$$TimeComponent$$$$HandleMouseClick$$($dvt$$19$$) {
    this.$handleShapeClick$($dvt$$19$$, $dvt$$19$$.ctrlKey && "multiple" == this.$_selectionMode$);
  };
  $dvt$$19$$.$TimeComponent$.prototype.$endPan$ = function $$dvt$$19$$$$TimeComponent$$$$endPan$$() {
    this.$_triggerViewportChange$ && (this.$_triggerViewportChange$ = !1, this.dispatchEvent(this.$createViewportChangeEvent$()));
  };
  $dvt$$19$$.$TimeComponent$.prototype.$contDragPan$ = function $$dvt$$19$$$$TimeComponent$$$$contDragPan$$($dvt$$19$$, $compY$$5$$) {
    if (this.$_currentX$ && this.$_currentY$) {
      var $deltaX$$18$$ = this.$_currentX$ - $dvt$$19$$, $deltaY$$18$$ = this.$_currentY$ - $compY$$5$$;
      if (0 == $deltaX$$18$$ && 0 == $deltaY$$18$$) {
        return !1;
      }
      this.$_triggerViewportChange$ = !0;
      this.$_currentX$ = $dvt$$19$$;
      this.$_currentY$ = $compY$$5$$;
      this.$panBy$($deltaX$$18$$, $deltaY$$18$$);
      return !0;
    }
    return !1;
  };
  $dvt$$19$$.$TimeComponent$.prototype.$panBy$ = function $$dvt$$19$$$$TimeComponent$$$$panBy$$($dvt$$19$$) {
    this.$panZoomCanvasBy$($dvt$$19$$);
  };
  $dvt$$19$$.$TimeComponentEventManager$ = function $$dvt$$19$$$$TimeComponentEventManager$$($dvt$$19$$) {
    this.Init($dvt$$19$$.$getCtx$(), $dvt$$19$$.$processEvent$, $dvt$$19$$);
    this.$_comp$ = $dvt$$19$$;
    this.$_isPinchZoom$ = this.$_isDragPanning$ = !1;
  };
  $dvt$$19$$.$Obj$.$createSubclass$($dvt$$19$$.$TimeComponentEventManager$, $dvt$$19$$.$EventManager$);
  $dvt$$19$$.$TimeComponentEventManager$.$GECKO_MOUSEWHEEL$ = "wheel";
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$addListeners$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$addListeners$$($displayable$$87$$) {
    $dvt$$19$$.$TimeComponentEventManager$.$superclass$.$addListeners$.call(this, $displayable$$87$$);
    $dvt$$19$$.$SvgDocumentUtils$.$addDragListeners$(this.$_comp$, this.$_onDragStart$, this.$_onDragMove$, this.$_onDragEnd$, this);
    $dvt$$19$$.$Agent$.$isTouchDevice$() || ($dvt$$19$$.$Agent$.$isPlatformGecko$() ? $displayable$$87$$.$addEvtListener$($dvt$$19$$.$TimeComponentEventManager$.$GECKO_MOUSEWHEEL$, this.$OnMouseWheel$, !1, this) : $displayable$$87$$.$addEvtListener$($dvt$$19$$.MouseEvent.$MOUSEWHEEL$, this.$OnMouseWheel$, !1, this));
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$RemoveListeners$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$RemoveListeners$$($displayable$$88$$) {
    $dvt$$19$$.$TimeComponentEventManager$.$superclass$.$RemoveListeners$.call(this, $displayable$$88$$);
    $dvt$$19$$.$Agent$.$isTouchDevice$() || ($dvt$$19$$.$Agent$.$isPlatformGecko$() ? $displayable$$88$$.$removeEvtListener$($dvt$$19$$.$TimeComponentEventManager$.$GECKO_MOUSEWHEEL$, this.$OnMouseWheel$, !1, this) : $displayable$$88$$.$removeEvtListener$($dvt$$19$$.MouseEvent.$MOUSEWHEEL$, this.$OnMouseWheel$, !1, this));
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$OnFocus$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$OnFocus$$($event$$557$$) {
    $dvt$$19$$.$TimeComponentEventManager$.$superclass$.$OnFocus$.call(this, $event$$557$$);
    this.$_comp$.$HandleFocus$();
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$OnBlur$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$OnBlur$$($event$$558$$) {
    $dvt$$19$$.$TimeComponentEventManager$.$superclass$.$OnBlur$.call(this, $event$$558$$);
    this.$_comp$.$HandleBlur$();
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$OnKeyDown$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$OnKeyDown$$($event$$559$$) {
    $dvt$$19$$.$TimeComponentEventManager$.$superclass$.$OnKeyDown$.call(this, $event$$559$$);
    this.$_comp$.$HandleKeyDown$($event$$559$$);
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$OnClick$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$OnClick$$($event$$560$$) {
    this.$_isDragPanning$ || ($dvt$$19$$.$TimeComponentEventManager$.$superclass$.$OnClick$.call(this, $event$$560$$), this.$_comp$.$HandleMouseClick$($event$$560$$));
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$PreOnMouseDown$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$PreOnMouseDown$$($event$$561$$) {
    this.$_isDragPanning$ = !1;
    $dvt$$19$$.$TimeComponentEventManager$.$superclass$.$PreOnMouseDown$.call(this, $event$$561$$);
    this.$_comp$.$HandleMouseDown$($event$$561$$);
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$OnMouseWheel$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$OnMouseWheel$$($dvt$$19$$) {
    this.$_comp$.$HandleMouseWheel$($dvt$$19$$);
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$OnTouchStartBubble$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$OnTouchStartBubble$$($event$$563$$) {
    $dvt$$19$$.$TimeComponentEventManager$.$superclass$.$OnTouchStartBubble$.call(this, $event$$563$$);
    this.$_comp$.$HandleTouchStart$($event$$563$$);
    this.$_comp$.$getCtx$().$_stage$.$_SVGRoot$.parentNode.focus();
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$OnTouchEndBubble$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$OnTouchEndBubble$$($event$$564$$) {
    $dvt$$19$$.$TimeComponentEventManager$.$superclass$.$OnTouchEndBubble$.call(this, $event$$564$$);
    this.$_comp$.$HandleTouchEnd$($event$$564$$);
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$_onDragStart$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$_onDragStart$$($event$$565$$) {
    if (this.$_comp$.$hasValidOptions$()) {
      return $dvt$$19$$.$Agent$.$isTouchDevice$() ? this.$_onTouchDragStart$($event$$565$$) : this.$_onMouseDragStart$($event$$565$$);
    }
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$_onDragMove$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$_onDragMove$$($event$$566$$) {
    return $dvt$$19$$.$Agent$.$isTouchDevice$() ? this.$_onTouchDragMove$($event$$566$$) : this.$_onMouseDragMove$($event$$566$$);
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$_onDragEnd$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$_onDragEnd$$($event$$567$$) {
    return $dvt$$19$$.$Agent$.$isTouchDevice$() ? this.$_onTouchDragEnd$($event$$567$$) : this.$_onMouseDragEnd$($event$$567$$);
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$_getRelativePosition$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$_getRelativePosition$$($pageX$$8$$, $pageY$$8$$) {
    this.$_stageAbsolutePosition$ || (this.$_stageAbsolutePosition$ = this.$_context$.$getStageAbsolutePosition$());
    return new $dvt$$19$$.$Point$($pageX$$8$$ - this.$_stageAbsolutePosition$.x, $pageY$$8$$ - this.$_stageAbsolutePosition$.y);
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$_onMouseDragStart$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$_onMouseDragStart$$($event$$568_relPos$$54$$) {
    return $event$$568_relPos$$54$$.button != $dvt$$19$$.MouseEvent.$RIGHT_CLICK_BUTTON$ && ($event$$568_relPos$$54$$ = this.$_getRelativePosition$($event$$568_relPos$$54$$.pageX, $event$$568_relPos$$54$$.pageY), this.$_comp$.$getGraphicalAreaBounds$().$containsPoint$($event$$568_relPos$$54$$.x, $event$$568_relPos$$54$$.y)) ? (this.$_comp$.$beginDragPan$($event$$568_relPos$$54$$.x, $event$$568_relPos$$54$$.y), !0) : !1;
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$_onMouseDragMove$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$_onMouseDragMove$$($dvt$$19$$) {
    $dvt$$19$$ = this.$_getRelativePosition$($dvt$$19$$.pageX, $dvt$$19$$.pageY);
    this.$_comp$.$contDragPan$($dvt$$19$$.x, $dvt$$19$$.y) && (this.$_isDragPanning$ = !0);
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$_onMouseDragEnd$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$_onMouseDragEnd$$() {
    this.$_comp$.$endDragPan$();
    this.$_stageAbsolutePosition$ = null;
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$_onTouchDragStart$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$_onTouchDragStart$$($event$$571_relPos$$56$$) {
    var $relPos2$$2_touches$$9$$ = $event$$571_relPos$$56$$.touches, $bounds$$128$$ = this.$_comp$.$getGraphicalAreaBounds$();
    if (1 == $relPos2$$2_touches$$9$$.length) {
      if ($event$$571_relPos$$56$$ = this.$_getRelativePosition$($relPos2$$2_touches$$9$$[0].pageX, $relPos2$$2_touches$$9$$[0].pageY), $bounds$$128$$.$containsPoint$($event$$571_relPos$$56$$.x, $event$$571_relPos$$56$$.y)) {
        return this.$_comp$.$beginDragPan$($event$$571_relPos$$56$$.x, $event$$571_relPos$$56$$.y), !0;
      }
    } else {
      if (2 == $relPos2$$2_touches$$9$$.length) {
        this.$_comp$.$endDragPan$();
        this.$_isPinchZoom$ = !0;
        var $relPos1$$2$$ = this.$_getRelativePosition$($relPos2$$2_touches$$9$$[0].pageX, $relPos2$$2_touches$$9$$[0].pageY), $relPos2$$2_touches$$9$$ = this.$_getRelativePosition$($relPos2$$2_touches$$9$$[1].pageX, $relPos2$$2_touches$$9$$[1].pageY);
        if ($bounds$$128$$.$containsPoint$($relPos1$$2$$.x, $relPos1$$2$$.y) && $bounds$$128$$.$containsPoint$($relPos2$$2_touches$$9$$.x, $relPos2$$2_touches$$9$$.y)) {
          return this.$_comp$.$beginPinchZoom$($relPos1$$2$$.x, $relPos1$$2$$.y, $relPos2$$2_touches$$9$$.x, $relPos2$$2_touches$$9$$.y), $dvt$$19$$.$EventManager$.$consumeEvent$($event$$571_relPos$$56$$), !0;
        }
      }
    }
    return !1;
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$_onTouchDragMove$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$_onTouchDragMove$$($dvt$$19$$) {
    var $relPos2$$3_touches$$10$$ = $dvt$$19$$.touches;
    if (1 == $relPos2$$3_touches$$10$$.length) {
      var $relPos$$57_relPos1$$3$$ = this.$_getRelativePosition$($relPos2$$3_touches$$10$$[0].pageX, $relPos2$$3_touches$$10$$[0].pageY);
      this.$_comp$.$contDragPan$($relPos$$57_relPos1$$3$$.x, $relPos$$57_relPos1$$3$$.y);
      $dvt$$19$$.preventDefault();
    } else {
      2 == $relPos2$$3_touches$$10$$.length && ($relPos$$57_relPos1$$3$$ = this.$_getRelativePosition$($relPos2$$3_touches$$10$$[0].pageX, $relPos2$$3_touches$$10$$[0].pageY), $relPos2$$3_touches$$10$$ = this.$_getRelativePosition$($relPos2$$3_touches$$10$$[1].pageX, $relPos2$$3_touches$$10$$[1].pageY), this.$_comp$.$contPinchZoom$($relPos$$57_relPos1$$3$$.x, $relPos$$57_relPos1$$3$$.y, $relPos2$$3_touches$$10$$.x, $relPos2$$3_touches$$10$$.y), $dvt$$19$$.preventDefault());
    }
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$_onTouchDragEnd$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$_onTouchDragEnd$$($dvt$$19$$) {
    this.$_isPinchZoom$ ? (this.$_isPinchZoom$ = !1, this.$_comp$.$endPinchZoom$()) : this.$_comp$.$endDragPan$();
    $dvt$$19$$.preventDefault();
    this.$_stageAbsolutePosition$ = null;
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$zoomBy$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$zoomBy$$($dvt$$19$$) {
    this.$_comp$.$zoomBy$($dvt$$19$$);
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$panBy$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$panBy$$($dx$$22$$, $dy$$24$$) {
    var $deltaX$$20$$ = $dx$$22$$ * this.$_comp$.$_canvasLength$ * ($dvt$$19$$.$Agent$.$isRightToLeft$(this.$_context$) ? -1 : 1), $deltaY$$20$$ = $dy$$24$$ * this.$_comp$.$_canvasSize$;
    0 != $deltaX$$20$$ && (this.$_comp$.$_triggerViewportChange$ = !0);
    this.$_comp$.$panBy$($deltaX$$20$$, $deltaY$$20$$);
    this.$_comp$.$endPan$();
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$HandleZoomInClick$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$HandleZoomInClick$$() {
    this.$_comp$.$handleZoom$(!0);
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$HandleZoomOutClick$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$HandleZoomOutClick$$() {
    this.$_comp$.$handleZoom$(!1);
  };
  $dvt$$19$$.$TimeComponentEventManager$.prototype.$GetTouchResponse$ = function $$dvt$$19$$$$TimeComponentEventManager$$$$GetTouchResponse$$() {
    return $dvt$$19$$.$EventManager$.$TOUCH_RESPONSE_TOUCH_HOLD$;
  };
  $dvt$$19$$.$TimeComponentKeyboardHandler$ = function $$dvt$$19$$$$TimeComponentKeyboardHandler$$($dvt$$19$$) {
    this.Init($dvt$$19$$);
  };
  $dvt$$19$$.$Obj$.$createSubclass$($dvt$$19$$.$TimeComponentKeyboardHandler$, $dvt$$19$$.$KeyboardHandler$);
  $dvt$$19$$.$TimeComponentKeyboardHandler$.prototype.$isSelectionEvent$ = function $$dvt$$19$$$$TimeComponentKeyboardHandler$$$$isSelectionEvent$$($dvt$$19$$) {
    return this.$isNavigationEvent$($dvt$$19$$) && !$dvt$$19$$.ctrlKey;
  };
  $dvt$$19$$.$TimeComponentKeyboardHandler$.prototype.$isMultiSelectEvent$ = function $$dvt$$19$$$$TimeComponentKeyboardHandler$$$$isMultiSelectEvent$$($event$$577$$) {
    return $event$$577$$.keyCode == $dvt$$19$$.KeyboardEvent.$SPACE$ && $event$$577$$.ctrlKey;
  };
  $dvt$$19$$.$TimeComponentKeyboardHandler$.prototype.$processKeyDown$ = function $$dvt$$19$$$$TimeComponentKeyboardHandler$$$$processKeyDown$$($event$$578$$) {
    if ($dvt$$19$$.KeyboardEvent.$isPlus$($event$$578$$) || $dvt$$19$$.KeyboardEvent.$isEquals$($event$$578$$)) {
      this.$_eventManager$.$HandleZoomInClick$();
    } else {
      if ($dvt$$19$$.KeyboardEvent.$isMinus$($event$$578$$) || $dvt$$19$$.KeyboardEvent.$isUnderscore$($event$$578$$)) {
        this.$_eventManager$.$HandleZoomOutClick$();
      } else {
        var $keyCode$$34$$ = $event$$578$$.keyCode;
        $keyCode$$34$$ == $dvt$$19$$.KeyboardEvent.$PAGE_UP$ ? ($event$$578$$.shiftKey ? this.$_eventManager$.$panBy$(-.25, 0) : this.$_eventManager$.$panBy$(0, -.25), $dvt$$19$$.$EventManager$.$consumeEvent$($event$$578$$)) : $keyCode$$34$$ == $dvt$$19$$.KeyboardEvent.$PAGE_DOWN$ && ($event$$578$$.shiftKey ? this.$_eventManager$.$panBy$(.25, 0) : this.$_eventManager$.$panBy$(0, .25), $dvt$$19$$.$EventManager$.$consumeEvent$($event$$578$$));
      }
    }
    return $dvt$$19$$.$TimeComponentKeyboardHandler$.$superclass$.$processKeyDown$.call(this, $event$$578$$);
  };
  var $DvtTimeComponentStyleUtils$$ = {};
  $dvt$$19$$.$Obj$.$createSubclass$($DvtTimeComponentStyleUtils$$, $dvt$$19$$.$Obj$);
  $DvtTimeComponentStyleUtils$$.$_DEFAULT_TIME_DIR_SCROLLBAR_STYLE$ = "height: 3px; width: 3px; color: #9E9E9E; background-color: #F0F0F0";
  $DvtTimeComponentStyleUtils$$.$_DEFAULT_CONTENT_DIR_SCROLLBAR_STYLE$ = "height: 3px; width: 3px; color: #9E9E9E; background-color: #F0F0F0";
  $DvtTimeComponentStyleUtils$$.$_SCROLLBAR_PADDING$ = 4;
  $DvtTimeComponentStyleUtils$$.$getTimeDirScrollbarStyle$ = function $$DvtTimeComponentStyleUtils$$$$getTimeDirScrollbarStyle$$() {
    return new $dvt$$19$$.$CSSStyle$($DvtTimeComponentStyleUtils$$.$_DEFAULT_TIME_DIR_SCROLLBAR_STYLE$);
  };
  $DvtTimeComponentStyleUtils$$.$getContentDirScrollbarStyle$ = function $$DvtTimeComponentStyleUtils$$$$getContentDirScrollbarStyle$$() {
    return new $dvt$$19$$.$CSSStyle$($DvtTimeComponentStyleUtils$$.$_DEFAULT_CONTENT_DIR_SCROLLBAR_STYLE$);
  };
  $DvtTimeComponentStyleUtils$$.$getScrollbarPadding$ = function $$DvtTimeComponentStyleUtils$$$$getScrollbarPadding$$() {
    return $DvtTimeComponentStyleUtils$$.$_SCROLLBAR_PADDING$;
  };
})(dvt);
